<script setup lang="ts">
  import { CmsElementProductListing } from '@shopware-pwa/composables-next';
  import { ShopwareSearchParams, ListingResult, Product } from '@shopware-pwa/types';
  import { CmsActionType } from '~/logic/interfaces';
  import { CmsPageKey, CmsSlotKey } from '~/helpers/injection';

  const { isGuide } = useUser();
  const cmsPageInject = inject(CmsPageKey);
  const cmsSlotInject = inject(CmsSlotKey);
  const {
    publishScrollTo,
    setContainerRef,
    publishHoverStart: publishHoverStartFunc,
    publishHoverEnd,
    publishHover: publishHoverFunc,
  } = useElementInteraction();
  const container = ref<any>();
  const props = defineProps<{
    content: CmsElementProductListing;
  }>();
  const id = ref<string>();
  const { requestDynamicPage, requestCloseSpecificDynamicPage } = useDynamicPage();
  const { productListingLoadedMoreInfo, stateForAll } = usePresentationState();
  const containerId = `${props.content.customFields?._uniqueIdentifier as string}-container`;
  const listingType =
    cmsPageInject?.type === 'presentation' ? 'presentationListing' : 'categoryListing';
  const options =
    cmsPageInject?.type === 'presentation'
      ? {
          pageId: cmsPageInject?.options?.groupId,
          slideId: cmsPageInject?.options?.sectionId,
        }
      : undefined;

  const {
    loading,
    getElements,
    loadingMore,
    loadMore,
    setInitialListing,
    getCurrentPage,
    changeCurrentPage,
    getTotalPagesCount,
  } = useListing(
    {
      listingType,
      defaultSearchCriteria: {
        limit: 60,
      },
    },
    options,
  );
  const { mercurePublish } = useMercure();
  const route = useRoute();
  const running = ref();
  const router = useRouter();
  const promisedLoadMoreMap = ref<Map<number, () => Promise<void>>>(new Map());

  onMounted(async () => {
    setContainerRef(containerId, container.value.scrollerTarget);
    if (listingType === 'presentationListing') {
      if (stateForAll.value?.currentDynamicPage?.type === DynamicPageType.PRODUCT_LIST) {
        const expectPage = stateForAll.value?.currentDynamicPage.page;
        await changeCurrentPage(1);
        if (expectPage < 2) return;
        buildPromisedLoadMoreMap(2, expectPage);
      } else {
        await changeCurrentPage(1);
        if (isGuide.value) {
          const res = await requestDynamicPage(
            {
              type: DynamicPageType.PRODUCT_LIST,
              page: 1,
            },
            false,
          );
          id.value = res?.id;
        }
      }
    } else {
      // with default listing, will get from cms data
      setInitialListing(props?.content?.data?.listing as Partial<ListingResult<Product>>);
    }
  });

  onUnmounted(() => {
    if (listingType === 'presentationListing' && id.value) {
      requestCloseSpecificDynamicPage({
        id: id.value,
        type: DynamicPageType.PRODUCT_LIST,
      });
    }
  });

  const buildPromisedLoadMoreMap = (initialValue: number, expectValue: number) => {
    for (let p = initialValue; p <= expectValue; p++) {
      if (!promisedLoadMoreMap.value.has(p)) {
        promisedLoadMoreMap.value.set(p, () => loadMore({ p }));
      }
    }
    running.value = true;
  };

  const changePage = async (page: number) => {
    await router.push({
      query: {
        ...route.query,
        p: page,
      },
    });
    changeCurrentPage(page, route.query as Partial<ShopwareSearchParams>);
  };

  const isProductListing = computed(() => props.content?.type === 'product-listing');

  const handleLoadMore = async () => {
    if (getTotalPagesCount.value <= getCurrentPage.value) return;
    await loadMore();
    mercurePublish.all(MercureEvent.DYNAMIC_PRODUCT_LISTING_PAGE_LOADED_MORE, {
      type: 'productList',
      page: getCurrentPage.value,
    });
    if (isGuide.value) {
      requestDynamicPage(
        {
          type: DynamicPageType.PRODUCT_LIST,
          page: getCurrentPage.value,
        },
        false,
        id.value,
      );
    }
  };

  const handlePublish = (productId: string, index: number) => {
    publishScrollTo(props.content.customFields?._uniqueIdentifier as string, productId, [
      {
        elementId: containerId,
        type: CmsActionType.VIRTUAL_SCROLLING,
        itemIndex: index,
      },
    ]);
  };

  const buildProductId = (productId: string) => {
    return `${cmsSlotInject?.elementId}-${productId}`;
  };

  const publishHoverStart = (productId: string, index: number) => {
    publishHoverStartFunc(props.content.customFields?._uniqueIdentifier as string, productId, [
      {
        elementId: containerId,
        type: CmsActionType.VIRTUAL_SCROLLING,
        itemIndex: index,
      },
    ]);
  };

  const publishHover = (productId: string, index: number) => {
    publishHoverFunc(props.content.customFields?._uniqueIdentifier as string, productId, [
      {
        elementId: containerId,
        type: CmsActionType.VIRTUAL_SCROLLING,
        itemIndex: index,
      },
    ]);
  };

  watch(productListingLoadedMoreInfo, () => {
    if (listingType !== 'presentationListing') return;
    if (productListingLoadedMoreInfo.value?.type !== DynamicPageType.PRODUCT_LIST) return;
    const expectPage = productListingLoadedMoreInfo.value.page;
    if (getCurrentPage.value >= expectPage) return;

    buildPromisedLoadMoreMap(getCurrentPage.value + 1, expectPage);
  });

  watch(running, async () => {
    if (listingType !== 'presentationListing') return;
    if (!running) return;
    if (!promisedLoadMoreMap.value.size) {
      running.value = false;
      return;
    }
    while (promisedLoadMoreMap.value.size) {
      const [firstKey] = promisedLoadMoreMap.value.keys();
      const func = promisedLoadMoreMap.value.get(firstKey);
      if (func) await func();
      promisedLoadMoreMap.value.delete(firstKey);
      if (!promisedLoadMoreMap.value.size) {
        running.value = false;
        if (isGuide.value) {
          requestDynamicPage(
            {
              type: DynamicPageType.PRODUCT_LIST,
              page: firstKey,
            },
            false,
            id.value,
          );
        }
      }
    }
  });

  const displayMode = computed(() => {
    if (props.content.config?.boxLayout?.value === 'minimal') {
      return 'contain';
    } else {
      return 'cover';
    }
  });
</script>

<template>
  <!-- generic elements for presentation listing -->
  <SwInfiniteProductList
    v-if="listingType === 'presentationListing'"
    :id="containerId"
    ref="container"
    :data="getElements"
    :is-loading-more="loading || loadingMore"
    should-set-container
    @load-more="handleLoadMore"
  >
    <template #default="{ product, index }">
      <div
        :id="buildProductId(product.id)"
        class="relative"
        @touchstart="publishHoverStart(buildProductId(product.id), index)"
        @touchend="publishHoverEnd()"
        @mouseenter="publishHoverStart(buildProductId(product.id), index)"
        @mouseleave="publishHoverEnd()"
        @click="publishHover(buildProductId(product.id), index)"
      >
        <template v-if="cmsPageInject?.type === 'presentation'">
          <SwTarget @publish="() => handlePublish(buildProductId(product.id), index)">
            <CmsProductCard
              :key="product.id"
              :data="product"
              :box-layout="content.config?.boxLayout?.value"
              :display-mode="displayMode"
            />
          </SwTarget>
        </template>
        <template v-else>
          <CmsProductCard
            :key="product.id"
            :data="product"
            :box-layout="content.config?.boxLayout?.value"
            :display-mode="displayMode"
          />
        </template>
      </div>
    </template>
  </SwInfiniteProductList>
  <!-- generic elements for default listing -->
  <div v-else class="bg-white">
    <div class="mx-auto max-w-2xl px-4 py-4 sm:px-6 sm:py-4 lg:max-w-7xl lg:px-8">
      <div v-if="getElements.length">
        <div
          class="mt-6 grid grid-cols-1 gap-x-6 gap-y-10 sm:grid-cols-2 lg:grid-cols-4 xl:gap-x-8"
        >
          <SwProductCard
            v-for="product in getElements"
            :key="product.id"
            :product="product"
            :is-product-listing="isProductListing"
          />
        </div>
        <div class="mt-10">
          <SwPagination
            :total="getTotalPagesCount"
            :current="Number(getCurrentPage)"
            @changePage="changePage"
          />
        </div>
      </div>
      <div v-else>
        <h2 class="mx-auto text-center">No products found 😔</h2>
      </div>
    </div>
  </div>
</template>
